// ===========================================================================
// ==         Actor class Definition                                        ==
// ==         Atchoum & X. Pinguin 22 April 2000                            ==
// ===========================================================================
#ifndef _ACTOR_H
#define _ACTOR_H

#include "Graphism/Sprite.h"
#include "Data/DataActor.h"

class RenderActor;
class DataRoom;

/**
 */
class Actor
{
public:
  /** */
  Actor(int x, int y, int z = 0);
  /** */
  virtual ~Actor();
  /** */
  virtual bool setAction(int action);
  /** */
  virtual bool setAction() = 0;
  /** */
  virtual bool mustRedraw() const = 0;
  /** */
  virtual void doAction() = 0;
  /** */
  RenderActor& getRenderObj();
  /** */
  bool canControling() const;
  /** */
  bool hasMoved() const
  {
    return _hasMoved;
  }
  /** */
  DataActor& getData();
  /** */
  virtual Actor* clone(DataRoom& room, int x, int y, int z=0) const = 0;
protected:
  //
  DataActor _data;
  //
  RenderActor* _renderObj;
  //
  bool _canBeControled;
  //
  bool _hasMoved;
};
// ================= INLINE SECTION ==========================================
inline
Actor::Actor(int x, int y, int z) :
  _data(x,y,z), _renderObj(NULL)
{
}
// ===========================================================================  
inline RenderActor&
Actor::getRenderObj()
{
  return *_renderObj;
}
// ===========================================================================
inline bool
Actor::canControling() const
{
  return _canBeControled;
}
// ===========================================================================
inline DataActor&
Actor::getData()
{
  return _data;
}
#endif
