// ===========================================================================
// ==              Class DataActor : Definition                             ==
// ==                Atchoum & X. Pinguin April 2000                        ==
//===========================================================================
#ifndef _DATAACTOR_H
#define _DATAACTOR_H

/**
   Data for the representation of a Actor. This datas are a class for IA.
 */
class DataActor
{
public:
  /** */
  DataActor(int x, int y, int z);
  /** */
  void setPosition(int x, int y, int z = 0);
  /** */
  void getPosition(int& x, int& y) const;
  /** */
  void getPosition(int& x, int& y, int& z) const;
  /** */
  int getXPos() const;
  /** */
  int getYPos() const;
  /** */
  int getZPos() const;
  /** */
  void move(int deltax, int deltay, int deltaz = 0);
  /** */
  int getFaction() const;
  /** */
  void setFaction(int faction);
  /** */
  int getState() const;
  /** */
  void setState(int state);
private:
  int _x, _y, _z;
  int _faction, _state;
}; // End DataActor class.
// =================== INLINE SECTION ========================================
inline int
DataActor::getXPos() const
{
  return _x;
}
// ===========================================================================
inline int
DataActor::getYPos() const
{
  return _y;
}
// ===========================================================================
inline int
DataActor::getZPos() const
{
  return _z;
}
// ===========================================================================
inline void
DataActor::setState(int state)
{
  _state = state;
}
// ===========================================================================
inline int
DataActor::getState() const
{
  return _state;
}
// ===========================================================================
inline void
DataActor::setPosition(int x, int y, int z)
{
  _x = x; _y = y; _z = z;
}
#endif
