// ========================================================================
// ==       Class DataRoom : Definition                                  ==
// ==              Atchoum & X Pinguin 16 Fevrier 2000                   ==
// ========================================================================
#ifndef _DATAROOM_H
#define _DATAROOM_H

#include <vector>

#include "Data/StaticRoom.h"
#include "Data/DynamicRoom.h"

/** 
*/
class DataRoom
{
 public:
  /** */
  DataRoom(int lx, int ly, int lz = 1);
  /** */
  const StaticRoom& getStaData() const;
  /** */
  StaticRoom& getStaData();
  /** */
  const DynamicRoom& getDynData() const;
  /** */
  DynamicRoom& getDynData();
 private:
  StaticRoom  _staRoom;
  DynamicRoom _dynRoom;
};

// ===================== INLINE SECTION ===================================
inline const StaticRoom&
DataRoom::getStaData() const
{
  return _staRoom;
}
// ===========================================================================
inline StaticRoom&
DataRoom::getStaData()
{
  return _staRoom;
}
// ===========================================================================
inline const DynamicRoom&
DataRoom::getDynData() const
{
  return _dynRoom;
}
// ===========================================================================
inline DynamicRoom&
DataRoom::getDynData()
{
  return _dynRoom;
}
#endif
