// ===========================================================================
// ==           DynamicRoom implementation                                  ==
// ==             Atchoum & X. Pinguin 19 April 2000                        ==
// ===========================================================================
#include <algorithm>

#include "DynamicRoom.h"
#include "DataActor.h"

DynamicRoom::~DynamicRoom()
{
}
// ===========================================================================
void
DynamicRoom::push(DataActor& actor, int x, int y, int z)
{
  actor.setPosition(x,y,z);
  _datas.push_back(&actor);
}
// ===========================================================================
bool
DynamicRoom::remove(DataActor& actor)
{
  _datas.remove(&actor);
	return true;
}
// ===========================================================================
DataActor*
DynamicRoom::getDataActor(int x, int y, int z)
{
  DataActor* ptActor = NULL;
  for (DynamicRoom::iterator itr = begin(); itr != end(); itr++)
  {
    if (((*itr)->getXPos()==x)&&
	((*itr)->getYPos()==y)&&
	((*itr)->getZPos()==z))
    {
      ptActor = *itr;
      break;
    }
  }
  return ptActor;
}
// ===========================================================================
const DataActor*
DynamicRoom::getDataActor(int x, int y, int z) const
{
  const DataActor* ptActor = NULL;
  for (DynamicRoom::const_iterator itr = begin(); itr != end(); itr++)
  {
    if (((*itr)->getXPos()==x)&&
	((*itr)->getYPos()==y)&&
	((*itr)->getZPos()==z))
    {
      ptActor = *itr;
      break;
    }
  }
  return ptActor;
}
