// ===========================================================================
// ==              Class Text : Implementation                              ==
// ==              Atchoum & X. Pinguin 6 Avril 2000                        ==
// ===========================================================================

#include "Graphism/Text.h"
#include "Graphism/Screen.h"

static Font* defaultFont = NULL;//("Alphabet.bmp");

Text::Text(const std::string& text, int x, int y) :
  _pos(0),
  _text(text),
  _font(NULL),
  _x(x), _y(y)
{
  if (defaultFont == NULL)
    defaultFont = new Font("Alphabet.bmp");
  _font = new Font(*defaultFont);
}
// ===========================================================================
Text::~Text()
{
  delete _font;
}
// ===========================================================================
Screen&
operator<<(Screen& scr, const Text& aText)
{
  const Font& f = aText.getFont();
  Sprite& spr = f.getSpr();
  int x,y;
  aText.getPosition(x,y);
  for (int c = aText.beginFrame();
       c != -1; c = aText.nextFrame() )
  {
    spr.setNewPos(x,y);
    //    cerr << " c = " << c << endl;
    int c1 = c>>4;
    int c2 = c-(c1<<4);
    spr.setPosition(c1);
    spr.setFrame(c2);
    scr << spr;
    x += spr.getWidth();
  }
  return scr;
}
