// =============================================================================
// ==                      class ModPlayer : Definition                       ==
// ==                    Atchoum & X. Pinguin   3 Mars 2000                   ==
// =============================================================================
#ifndef _MODPLAYER_H
#define _MODPLAYER_H

#include <string>

struct SDL_Thread;
struct MODULE;
/** Cette classe permet de joueur en background ( thread ) un fichier mod
    grce  la bibliothque mikMod. */
class ModPlayer
{
public:
  /** Ce constructeur initialise les drivers pour mikMod. */
  ModPlayer();
  /** Ce destructeur restaure les drivers pour mikMod. */
  ~ModPlayer();
  /** Pour charger un module musical. */
  bool load(const std::string& name);
  /** Pour jouer une module musical charg pralablement. */
  bool play();
  /** Mettre en pause l'coute quand on joue un morceau. */
  bool pause();
  /** Remet le morceau au dbut. Ne marche pas pour l'instant. */
  void rewind();
  /** Arrte de jouer le morceau. */
  bool stop();
  /** Pour savoir si un morceau est en train d'tre jou ou non. */
  bool isPlaying();

private:
  MODULE* _module;  
  bool    _isQuitting;
  
  SDL_Thread* _thread;

  static int PlayModule(void*);
};

#endif
