// ===========================================================================
// ==             RenderBase class definition                               ==
// ==             Atchoum & X. Pinguin 24 April 2000                        ==
// ===========================================================================
#ifndef _RENDERBASE_H
#define _RENDERBASE_H

#include "Graphism/Sprite.h"
#include "Graphism/Screen.h"

/**
   Base class for any thing which must be rendered on the scenary.
*/
class RenderBase
{
public:
  /** */
  RenderBase();
  /** */
  virtual ~RenderBase();
  /** */
  virtual Screen& render(Screen& screen) = 0;
  /** */
  bool mustRedraw() const;
  /** */
  void setMustRedraw();
protected:
  /** */
  void setSprite(const Sprite& spr);
  Sprite * _spr;
  bool _mustRedraw;
};
// ==================== INLINE SECTION =======================================
inline Screen&
operator<<(Screen& scr, RenderBase& obj)
{
  return obj.render(scr);
}
// ===========================================================================
inline RenderBase::RenderBase() : 
  _spr(NULL),
  _mustRedraw(true)
{
}
// ===========================================================================
inline void RenderBase::setSprite(const Sprite& spr)
{
  _spr = new Sprite(spr);
}
// ===========================================================================
inline bool
RenderBase::mustRedraw() const
{
  return _mustRedraw;
}
// ===========================================================================
inline void
RenderBase::setMustRedraw()
{
  _mustRedraw = true;
}
#endif
