// ===========================================================================
// ==          RenderPlayer class implementation                            ==
// ==          Atchoum & X. Pinguin 24 April 2000                           ==
// ===========================================================================

#include "Render/RenderPlayer.h"
#include "Data/ActionId.h"
#include "Graphism/Image.h"
#include "Graphism/Sprite.h"

static Image*  playerImg = NULL;
static Sprite* playerSpr = NULL;

RenderPlayer::RenderPlayer() : RenderActor()
{
  if (playerImg == NULL)
  {
    playerImg = new Image("Graphisme/Joueur.bmp");
    playerSpr = new Sprite(*playerImg, 7, 5, 0, true);
    playerImg->setTransparentPixel(0,0);
  }
  setSprite(*playerSpr);
}
// ===========================================================================
Screen&
RenderPlayer::render(Screen& scr)
{
  scr << *_spr;
  _spr->nextFrame();
  return scr;
}
// ===========================================================================
void
RenderPlayer::setState(int pos)
{
  switch(pos)
  {
  case MOVELEFT:
    _spr->setPosition(2);
    break;
  case MOVERIGHT:
    _spr->setPosition(4);
    break;
  case MOVEUP:
    _spr->setPosition(3);
    break;
  case MOVEDOWN:
    _spr->setPosition(1);
    break;
  default:
    _spr->setPosition(0);
    break;
  }
}
// ===========================================================================
RenderActor*
RenderPlayer::clone() const
{
  return new RenderPlayer;
}
