// ===========================================================================
// ==         Scenary class : Definition                                    ==
// ==            Atchoum & X. Pinguin 22 April 2000                         ==
// ===========================================================================
#ifndef _SCENARY_H
#define _SCENARY_H_

#include <list>
#include <vector>

#include "Data/DataRoom.h"
#include "Render/RenderRoom.h"

class Object;
class Actor;
class Player;
class Screen;

/**
   It's the scenary motor. For all games, it render the scene and
   control the interactivity between actors and decors.
*/
class Scenary
{
public:
  /**
   */
  Scenary(int lx, int ly, int lz = 1);
  /**
     It's the decor object.
   */
  ~Scenary();
  /**
   */
  bool addObject(const Object& obj, int x, int y);
  /**
   */
  bool rmObject(int x, int y, int z);
  /**
   */
  bool addPlayer(int score, int energy, int x, int y);
  /**
   */
  bool addActor(const Actor& actor, int x, int y);
  /**
   */
  DataRoom& getRoom();
  /**
   */
  bool play(Screen& scr);
  /**
   */
  Player& getPlayer();
  /**
   */
  int getNbDiam() const
  {
    return _nbOfDiamonds;
  }
  /**
   */
  int getScore() const
  {
    return _score;
  }
private:
  void ValidAction( Actor& actor) const;
  DataRoom   _data;
  RenderRoom _render;
  std::list<Actor*>  _listOfActor;
  std::list<Object*> _vectOfObject;
  int _lx, _ly, _lz;
  int _nbOfDiamonds;
  int _score;
  Player* _player;
};
// ============== INLINE SECTION =============================================
inline DataRoom&
Scenary::getRoom()
{
  return _data;
}
// ===========================================================================
inline Player&
Scenary::getPlayer()
{
  return *_player;
}
#endif
